members/urls.py
from django.urls import path
from django.views.generic import RedirectView

from . import views


def cause_error(request):
    raise Exception("Hello, I'm an error. Isn't that great?")


app_name = "members"
urlpatterns = [
    path("<int:pk>/", views.DetailView.as_view(), name="detail"),
    path(
        "<int:pk>/achievements",
        RedirectView.as_view(pattern_name="userachievements"),
        name="redirect_userachievements",
    ),
    path("verjaardagen/", views.BirthdaysView, name="birthdays"),
    path("ingelogd", views.logged_in_redirect, name="logged_in"),
    path("", views.PersonListView.as_view(), name="list"),
    path("bewerken/<int:pk>", views.EditView.as_view(), name="edit"),
    path("error", cause_error),
]

news/urls.py
from django.urls import path

from . import views

app_name = "news"
urlpatterns = [
    path("", views.NewsListView.as_view(), name="news_list"),
    path("<int:pk>/", views.NewsDetailView.as_view(), name="news_detail"),
]

unchained/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path, re_path
from django.views.generic import RedirectView, TemplateView

from wrinklypages import views as wpviews

from . import views

urlpatterns = [
    path("", RedirectView.as_view(pattern_name="home")),
    path("home/", views.index, name="home"),
    path("admin/doc/", include("django.contrib.admindocs.urls")),
    path("admin/", admin.site.urls),
    path("activiteiten/", include("activities.urls")),
    path("service/docuweb/", include("docuweb.urls")),
    path("pages/", include("django.contrib.flatpages.urls")),
    path("leden/", include("members.urls")),
    path("vereniging/nieuws/", include("news.urls")),
    path("accounts/", include("authentication.urls")),
    path("vereniging/commissies/", include("groups.urls")),
    path("achievements/", include("achievements.urls")),
    path("i18n/", include("django.conf.urls.i18n")),
    path("ideal/", include("ideal.urls")),
    path("carriere/", include("career.urls")),
    path("publisher/", include("wrinklypages.urls")),
    path("tinymce/", include("tinymce.urls")),
    path("__debug__/", include("debug_toolbar.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

members/models/membership.py
import datetime
from typing import Dict

from django.db import models
from django.db.models import F, Q

from unchained.junk_drawer import enum_field

from .person import Person


class Membership(models.Model):
    MEMBER: str = "member"
    BAL: str = "bal"  # Bijzonder Actief Lid
    MERIT: str = "merit"  # Lid van Verdienste
    HONORARY: str = "honorary"  # Erelid
    KIND: Dict[str, str] = {
        MEMBER: "member",
        BAL: "BAL",
        MERIT: "member of merit",
        HONORARY: "honorary member",
    }

    person: Person = models.ForeignKey(Person, on_delete=models.CASCADE)
    kind: str = enum_field(KIND, default=MEMBER)
    since: datetime = models.DateField()
    until: datetime = models.DateField(blank=True, null=True)

    def __str__(self) -> str:
        return f"{self.person} registered as a {self.kind}"

    class Meta:
        constraints = [
            models.CheckConstraint(
                name="membership_date_range_valid",
                check=Q(since__lte=F("until")) | Q(until=None),
            )
        ]

members/models/person.py
from __future__ import annotations

from datetime import datetime
from typing import Dict, Optional, Tuple

from django.apps import apps
from django.db import models
from django_countries.fields import CountryField
from phonenumber_field.modelfields import PhoneNumberField

from unchained.junk_drawer import enum_field


class Contact(models.Model):
    """Some minimal information to identify a person.

    This is the main API endpoint for members:
    other apps can use a Contact to identify people.

    If we need full personal details, use a Person
    that has this Contact as foreign key.
    """

    # Corresponds to Person.full_name
    # e.g. "Kobayashi von Servingman"
    name: str = models.CharField(max_length=1024)
    # Corresponds to Person.email
    email: str = models.EmailField()

    def __str__(self) -> str:
        return self.name


class PersonManager(models.Manager):
    """
    A manager for the Person model which doesn't return the anonymous user.
    """

    def get_queryset(self):
        User = apps.get_model("authentication.user")
        # this gets the User class as defined in authentication.models
        # not a straight import to prevent circular imports
        return super().get_queryset().exclude(pk=User.get_anonymous().person.pk)


class Person(models.Model):
    """A model for storing full personal details of people.

    Member administration uses this over Contact if they need the additional fields.
    Other apps should access the information via Contact.
    """

    contact: Contact = models.ForeignKey(Contact, on_delete=models.CASCADE)

    # e.g "Prof. Kobayashi Iras von Servingman"
    legal_name: str = models.CharField(max_length=1024)
    # e.g. "Kobayashi"
    given_name: str = models.CharField(max_length=1024)

    birth_date: datetime = models.DateField(null=True, blank=True)

    objects = PersonManager()
    # special manager returning all people except the person associated with the anonymous user

    all_objects = models.Manager()
    # TODO: comments? (made by the board)

    @classmethod
    def create_with_contact(
        cls,
        *,
        full_name: str,
        email: str,
        legal_name: str,
        given_name: str,
        birth_date: Optional[datetime] = None,
    ) -> Tuple[Person, Contact]:
        contact = Contact.objects.create(name=full_name, email=email)
        person = Person.all_objects.create(
            contact=contact,
            legal_name=legal_name,
            given_name=given_name,
            birth_date=birth_date,
        )
        return person, contact

    @property
    def full_name(self) -> str:
        # We don't include a setter, since the caller would also need to save the Contact.
        return self.contact.name

    @property
    def email(self) -> str:
        """The e-mail address of this person.

        Reads it out from the Contact information.
        """
        # We don't include a setter, since the caller would also need to save the Contact.
        return self.contact.email

    def __str__(self) -> str:
        return self.full_name

    @property
    def groups(self):
        group_memberships = self.groupmembership_set.all()
        groups = [group_membership.group for group_membership in group_memberships]
        return groups

    class meta:
        _default_manager_name = "PersonManager"


class PhoneNumber(models.Model):
    """A phone number associated with a person."""

    HOME: str = "home"
    MOBILE: str = "mobile"
    WORK: str = "work"
    EMERGENCY: str = "emergency"
    KIND: Dict[str, str] = {
        HOME: "home",
        MOBILE: "mobile",
        WORK: "work",
        EMERGENCY: "emergency",
    }

    person: Person = models.ForeignKey(Person, on_delete=models.CASCADE)

    kind: str = enum_field(KIND, default=HOME)
    number: str = PhoneNumberField()

    def __str__(self) -> str:
        return f"{self.number} ({PhoneNumber.KIND[self.kind]})"


class Address(models.Model):
    """An address associated with a person."""

    HOME: str = "home"
    BILLING: str = "billing"
    PARENTS: str = "parents"
    POSTAL: str = "postal"
    KIND: Dict[str, str] = {
        HOME: "home address",
        BILLING: "billing address",
        PARENTS: "parents' address",
        POSTAL: "postal address",
    }

    person: Person = models.ForeignKey(Person, on_delete=models.CASCADE)

    kind: str = enum_field(KIND, default=HOME)
    street: str = models.CharField(max_length=256)
    street_number: str = models.CharField(max_length=16)
    extra: Optional[str] = models.CharField(max_length=256, blank=True)
    postal_code: str = models.CharField(max_length=16)
    city: str = models.CharField(max_length=256)
    country: str = CountryField(default="NL")

    class Meta:
        verbose_name_plural = "addresses"

    def __str__(self) -> str:
        return f"{self.street} {self.street_number} {self.extra} ({Address.KIND[self.kind]})"

members/models/study_program.py
import datetime
from typing import Dict

from django.db import models
from django.db.models import F, Q

from unchained.junk_drawer import enum_field
from unchained.types.queryset import QueryType

from .person import Person


class StudyProgram(models.Model):
    """A specific study program that students may follow at UU.

    Dutch: 'studie' or 'opleiding'.
    """

    BACHELOR: str = "ba"
    MASTER: str = "ma"
    PHASE: Dict[str, str] = {BACHELOR: "bachelor", MASTER: "master"}

    # TODO: use a library like django-modeltranslation if we translate this field
    name: str = models.CharField(max_length=256)
    phase: str = enum_field(PHASE)
    # TODO: here we can also add an abbreviation (for translating user data to StudyProgram objects)

    students: QueryType[Person] = models.ManyToManyField(Person, through="Enrollment")

    def __str__(self) -> str:
        return f"{self.name} ({StudyProgram.PHASE[self.phase]})"


class Enrollment(models.Model):
    """Records that a person (typically a member of the association) is enrolled in a study program."""

    person: Person = models.ForeignKey(Person, on_delete=models.CASCADE)
    program: StudyProgram = models.ForeignKey(StudyProgram, on_delete=models.PROTECT)

    since: datetime = models.DateField()
    until: datetime = models.DateField(blank=True, null=True)

    class Meta:
        constraints = [
            models.CheckConstraint(
                name="enrollment_date_range_valid",
                check=Q(since__lte=F("until")) | Q(until=None),
            )
        ]

    def __str__(self) -> str:
        return f"{self.person} enrolled in {self.program}"

members/forms/userdata_form.py
from django import forms
from django.forms import inlineformset_factory, modelform_factory, modelformset_factory
from django.utils.translation import gettext_lazy as _
from phonenumber_field.formfields import PhoneNumberField
from phonenumber_field.widgets import RegionalPhoneNumberWidget

from ..models.person import Address, Contact, Person, PhoneNumber

ContactForm = modelform_factory(
    Contact, fields=("name", "email"), labels={"name": _("name"), "email": _("email")}
)
PersonForm = modelform_factory(
    Person,
    fields=("legal_name", "given_name", "birth_date"),
    labels={
        "legal_name": _("legal name"),
        "given_name": _("given_name"),
        "birth_date": _("birth_date"),
    },
    widgets={"birth_date": forms.DateInput(attrs={"type": "date"})},
)


AddressFormSet = inlineformset_factory(
    Person,
    Address,
    fields=(
        "kind",
        "street",
        "street_number",
        "extra",
        "postal_code",
        "city",
        "country",
    ),
    extra=1,
)

PhoneNumberFormSet = inlineformset_factory(
    Person,
    PhoneNumber,
    fields=("kind", "number"),
    labels={"kind": _("Soort"), "number": _("Nummer")},
    extra=1,
)

achievements/views/detailviews.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views import generic

from achievements.rewarding.achievement_utilities import person_has_achievement
from members.models.person import Person

from ..models import Achieved, Achievement, Medal, Received


class AchievementDetailView(LoginRequiredMixin, generic.DetailView):
    """
    this page shows in detail information about a specific achievement

    **authorised user only**

    **CONTEXT:**

        ``user_sees_achievement``
            bool which determines whether or not the current user has the rights to see this achievement

        ``achiever-list``
            a list of all people who have achieved this achievement

        ``num_visits``
            the number of times the current session has visited this specific achievement page in a row
            used for bad achievement lookup surprise

    **SESSION_DATA:**

        ``ACHIEVEMENTS_last_visited_achievement``
            abbrev field of the last visited achievement page,
            used to check if the current page is the same as the last page visited (used for surprise)

        ``ACHIEVEMENTS_num_visits``
            int telling how many times in a row this page has been visited by the current session

    **TEMPLATES:**

        :template:`../achievements/templates/achievements/achievement_detail.html`
    """

    model = Achievement

    slug_field = "abbrev"
    slug_url_kwarg = "name"

    def get_context_data(self, **kwargs):
        if (
            self.request.session.get("ACHIEVEMENTS_last_visited_achievement", "")
            == self.object.abbrev
        ):
            num_visits = self.request.session.get("ACHIEVEMENTS_num_visits", 0) + 1
        else:
            num_visits = 1
        self.request.session[
            "ACHIEVEMENTS_last_visited_achievement"
        ] = self.object.abbrev
        self.request.session["ACHIEVEMENTS_num_visits"] = num_visits
        user = self.request.user
        user_sees_achievement = (
            self.object.hidden
            or user.has_perm("achievements.can_see_all")
            or person_has_achievement(user.person, self.object)
        )

        context = super(AchievementDetailView, self).get_context_data(**kwargs)
        context["user_sees_achievement"] = user_sees_achievement
        context["achiever_list"] = Achieved.objects.filter(
            achievement=self.object
        ).filter(has_achieved=True)
        context["num_visits"] = num_visits
        # NOTE:
        #       type(user_sees_achievement)==Boolean
        #       type(achiever_list)==Queryset
        #       type(num_visits)==Integer
        return context


class MedalDetailView(LoginRequiredMixin, generic.DetailView):
    """
    This page shows detailed information about this :model:`achievements.medal`

    **authorised user only**

    **CONTEXT:**

        ``bronze_receiver_list``
            A list\* of all people who have the bronze rank in this medal

        ``silver_receiver_list``
            A list\* of all people who have the silver rank in this medal

        ``gold_receiver_list``
            A list\* of all people who have the gold rank in this medal

        ``platinum_receiver_list``
            A list\* of all people who have the platinum rank in this medal

        \* actually a queryset, but who cares amirite?
    **TEMPLATES:**
        :template:`../achievements/templates/achievements/medal_detail.html
    """

    model = Medal

    slug_field = "abbrev"
    slug_url_kwarg = "name"

    def get_context_data(self, *args, **kwargs):
        context = super(MedalDetailView, self).get_context_data(*args, **kwargs)
        context["bronze_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=1)
        context["silver_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=2)
        context["gold_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=3)
        context["platinum_receiver_list"] = Received.objects.filter(
            medal=self.object
        ).filter(rank__gte=4)
        return context

members/templates/members/birthdays.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}
Leden
{% endblock %}

{% block banner %}
    <h1 class="title">{% trans "Verjaardagen" %}</h1>
{% endblock %}

{% block body %}
    <h2 class="subtitle">{{date|date:"F"|title}}</h2>
    <div class="birthdays-buttons">
        <a href="?maand=1"class="button is-link">
            {% trans "Jan" %}
        </a>
        <a href="?maand=2"class="button is-link">
            {% trans "Feb" %}
        </a>
        <a href="?maand=3"class="button is-link">
            {% trans "Mrt" %}
        </a>
        <a href="?maand=4"class="button is-link">
            {% trans "Apr" %}
        </a>
        <a href="?maand=5"class="button is-link">
            {% trans "Mei" %}
        </a>
        <a href="?maand=6"class="button is-link">
            {% trans "Jun" %}
        </a>
        <a href="?maand=7"class="button is-link">
            {% trans "Jul" %}
        </a>
        <a href="?maand=8"class="button is-link">
            {% trans "Aug" %}
        </a>
        <a href="?maand=9"class="button is-link">
            {% trans "Sep" %}
        </a>
        <a href="?maand=10"class="button is-link">
            {% trans "Okt" %}
        </a>
        <a href="?maand=11"class="button is-link">
            {% trans "Nov" %}
        </a>
        <a href="?maand=12"class="button is-link">
            {% trans "Dec" %}
        </a>
    </div>
    <div class="birthdays-table">
        {% for day, persons in persons_by_date %}
            <div class="birthdays-day">
                <h3 class="is-size-5 has-text-weight-bold birthdays-headline">{{day}}</h3>
                <div>
                    {% for person in persons %}
                        <a href="{% url 'members:detail' person.id %}">{{person.full_name}}</a> ({{person.birth_date.year}})
                    <br>
                    {% endfor %}
                </div>
            </div>
        {% endfor %}
    </div>
    <div class="birthdays-buttons">
        <a href="?maand=1"class="button is-link">
            {% trans "Jan" %}
        </a>
        <a href="?maand=2"class="button is-link">
            {% trans "Feb" %}
        </a>
        <a href="?maand=3"class="button is-link">
            {% trans "Mrt" %}
        </a>
        <a href="?maand=4"class="button is-link">
            {% trans "Apr" %}
        </a>
        <a href="?maand=5"class="button is-link">
            {% trans "Mei" %}
        </a>
        <a href="?maand=6"class="button is-link">
            {% trans "Jun" %}
        </a>
        <a href="?maand=7"class="button is-link">
            {% trans "Jul" %}
        </a>
        <a href="?maand=8"class="button is-link">
            {% trans "Aug" %}
        </a>
        <a href="?maand=9"class="button is-link">
            {% trans "Sep" %}
        </a>
        <a href="?maand=10"class="button is-link">
            {% trans "Okt" %}
        </a>
        <a href="?maand=11"class="button is-link">
            {% trans "Nov" %}
        </a>
        <a href="?maand=12"class="button is-link">
            {% trans "Dec" %}
        </a>
    </div>
{% endblock %}

members/templates/members/detail.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}
{{ person.full_name }}
{% endblock %}

{% block banner %}
    <h1 class="title"> {{ person.full_name }} </h1>
{% endblock %}

{% block body %}
<h2 class="subtitle"> Nickname ofzo? </h2>

<div class="tabs is-centered">
    <ul>
        <li class="js-tab is-active"> <a>{% trans " Persoonsgegevens " %}</a> </li>
        <li class="js-tab"> <a>{% trans " Lidmaatschap & Studies " %}</a> </li>
        <li class="js-tab"> <a>{% trans " Commissies, groepen en disputen " %}</a> </li>
        <li class="js-tab"> <a>{% trans " Bezochte activiteiten " %}</a> </li>
    </ul>
</div>

<!-- Tab 1 -->

<div class="js-tab-content" id="personal">
    <div class="box">
        <h4 class="title is-4">{% trans " Persoonsgegevens " %}</h4>
        {% if user.is_authenticated %}
            {% if user.person.id == person.id %}
                <a class="button" href="/leden/bewerken/{{person.id}}">Bewerken...</a>
            {% endif %}
        {% endif %}
        <table class="table is-fullwidth is-striped">
            <tbody>
                <tr>
                    <th> <abb title="Legal name">{% trans " Wettelijke naam " %}</abbr> </th>
                    <td> {{ person.legal_name }} </td>
                </tr>
                <tr>
                    <th> <abb title="Given name">{% trans " Roepnaam " %}</abbr> </th>
                    <td> {{ person.given_name }} </td>
                </tr>
                <tr>
                    <th> <abb title="Full name">{% trans " Volledige naam " %}</abbr> </th>
                    <td> {{ person.full_name }} </td>
                </tr>
                <tr>
                    <th> <abb title="Email address">{% trans " Email " %}</abbr> </th>
                    <td> {{ person.email }} </td>
                </tr>
                <tr>
                    <th> <abb title="Birth date">{% trans " Geboortedatum " %}</abbr> </th>
                    <td> {{ person.birth_date }} </td>
                </tr>
            </tbody>
        </table>
    </div>

    <div class="box">
        <h4 class="title is-4">{% trans " Telefoonnummers " %}</h4>

        <ul>
            {% for number in person.phonenumber_set.all %}
                <li>{{ number }}</li>
            {% endfor %}
        </ul>
    </div>

    <div class="box">
        <h4 class="title is-4">{% trans " Adressen " %}</h4>

        <ul>
            {% for address in person.address_set.all %}
                <li>{{ address }}</li>
            {% endfor %}
        </ul>
    </div>
</div>

<!-- Tab 2 -->
<div class="js-tab-content" id="membership" style="display:none">
    <div class="box">
        <h4 class="title is-4">{% trans " Lidmaatschap " %}</h4>

        <ul>
            {% for membership in person.membership_set.all %}
                <li>{{membership}}</li>
            {% endfor %}
        </ul>
    </div>

    <div class="box">
        <h4 class="title is-4">{% trans " Studies " %}</h4>

        <ul>
            {% for study in person.enrollment_set.all %}
                <li>{{ study.program }}</li>
            {% endfor %}
        </ul>
    </div>
</div>

<!-- Tab 3 -->
<div class="js-tab-content" id="groups" style="display:none">
    {% with groups=person.groups %}
        <div class="box">
            <h4 class="title is-4">{% trans " Commissies " %}</h4>

            <ul>
                {% for group in groups %}
                    {% if group.kind == group.COMMITTEE %}
                        <li>{{ group }}</li>
                    {% endif %}
                {% endfor %}
            </ul>
        </div>

        <div class="box">
            <h4 class="title is-4">{% trans " Groepen " %}</h4>

            <ul>
                {% for group in groups %}
                    {% if group.kind == group.GROUP %}
                        <li>{{ group }}</li>
                    {% endif %}
                {% endfor %}
            </ul>
        </div>

        <div class="box">
            <h4 class="title is-4">{% trans " Disputen " %}</h4>

            <ul>
                {% for group in groups %}
                    {% if group.kind == group.SOCIETY %}
                        <li>{{ group }}</li>
                    {% endif %}
                {% endfor %}
            </ul>
        </div>
    {% endwith %}
</div>

<!-- Tab 4 -->
<div class="js-tab-content" id="activities" style="display:none">
    <div class="box">
        <h4 class="title is-4">{% trans " Bezochte activiteiten " %}</h4>

        <ul>
            {% for activity in person.contact.ticket_set.all %}
                <li>{{ activity.admittance.event }}</li>
            {% endfor %}
        </ul>
    </div>
</div>

{% endblock %}

{% block scripts_postload %}

<script>
    addTabEventListeners();
</script>

{{ block.super }}

{% endblock %}

members/templates/members/edit.html
{% extends "base.html" %}

{% block title %}
{{ person.full_name }}
{% endblock %}

{% block body %}
    {% load i18n %}
    {% load bulma_tags %}

    {% url "members:detail" person.pk as return_url %}

    {% trans "Naam en email" as nameFormTitle %}
    {% include "components/formbox.html" with forms=nameForms title=nameFormTitle form_id="nameForm"%}

    {% trans "Telefoonnummers " as phoneTitle %}
    {% include "components/formbox.html" with form=phoneFormset title=phoneTitle form_id="phoneForms"%}
    
    {% trans "Adressen " as addressTitle %}
    {% include "components/formbox.html" with form=addressFormset title=addressTitle form_id="addressForms"%}

{% endblock %}

members/templates/members/person_list.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}
Leden
{% endblock %}

{% block banner %}
    <h1 class="title">{% trans "Leden" %}</h1>
{% endblock %}

{% block body %}
    <h2 class="subtitle">{% trans "Zoek hier een lid" %}</h2>

    <table class="table is-fullwidth is-striped">
        <thead>
            <tr>
                <th>{% trans "Volledige naam" %}</th>
            </tr>
        </thead>
        <tbody>
            {% for person in person_list %}
                <tr>
                    <td>
                        <a href="{% url 'members:detail' person.id %}">{{person.full_name}}</a>
                    </td>
                </tr>
            {% endfor %}
        </tbody>
    </table>

    {% include "components/pagination.html"%}
{% endblock %}